import { select, json, geoPath, geoNaturalEarth1 } from 'd3';
import { feature } from 'topojson';

// Instantiates  the SVG object
const svg = select('svg');

// begin a new geoNaturalEarth1() object for generating and path projecting
const projection = geoNaturalEarth1();
const pathGenerator = geoPath().projection(projection);

// Retrieves data from the end point and then formats the projection as an Canvas image.
json('https://cdn.jsdelivr.net/npm/world-atlas@2/countries-110m.json')
  .then(data => {
  	// Pulls the all the countries from the data
    const countries = feature(data, data.objects.countries);
  	// Sends the extracted countries as data for generating the paths on an Canvas image
    svg.selectAll('path').data(countries.features)
      .enter().append('path')
        .attr('class', 'country')
        .attr('d', pathGenerator);
  });